////////////////////////////////////////////////////////////////////////
//
//	ComPort.cpp: implementation of the CComPort class
//
//	Author: Jurgis Armanavichius
//
//	Based on original CSerialPort class by Remon Spekreijse (thanks)
//
////////////////////////////////////////////////////////////////////////

#include <string.h>
#include "CComPort.cpp"
#include "ComPort.h"

//////////////////////////////////////////////////////////////////////
//
//	CComPort proper
//
//////////////////////////////////////////////////////////////////////

CComPort com_port;

//////////////////////////////////////////////////////////////////////
//
//	User interface routines to ComPort class
//
//////////////////////////////////////////////////////////////////////

void ComPort_PresetParameters(DWORD baud,BYTE databits,BYTE parity,BYTE stopbits)
{
  com_port.PresetComParameters(baud,databits,parity,stopbits);
}

BOOL ComPort_ChangeParameters(DWORD baud,BYTE databits,BYTE parity,BYTE stopbits)
{
  return com_port.ChangeComParameters(baud,databits,parity,stopbits);
}

BOOL ComPort_Open(char *name)
{
  return com_port.OpenCom(name);
}

void ComPort_Close(void)
{
  com_port.CloseCom();
}

DWORD ComPort_CheckInQueue(void)
{
  return com_port.CheckInQueue();
}

int ComPort_GetByte(DWORD dwMilliseconds)
{
  BYTE byt;

  if(com_port.GetByte(&byt,dwMilliseconds))
    return byt;
  else
    return -1;
}

BOOL ComPort_PutByte(BYTE byt)
{
  return com_port.PutByte(byt);
}

DWORD ComPort_ReadBlock(LPBYTE lpBuffer,DWORD nMax)
{
  return com_port.ReadBlock(lpBuffer,nMax);
}

BOOL ComPort_WriteBlock(LPBYTE lpBuffer,DWORD dwBufferLength)
{
  return com_port.WriteBlock(lpBuffer,dwBufferLength);
}

BOOL ComPort_GetOpenedStatus(void)
{
  return com_port.GetOpenedStatus();
}
