//
// ComPortExample.cpp : Defines the entry point for the console application.
//

#include <stdio.h>
#include <conio.h>
#include "..\\ComPort.h"

#define	 ESC			0x1B
#define	 PROTOCOL_ENABLE	0

struct {
  char *baudname;
  DWORD baudrate;
} BaudRates[] = {
  {   "110",   CBR_110},
  {   "300",   CBR_300},
  {   "600",   CBR_600},
  {  "1200",  CBR_1200},
  {  "2400",  CBR_2400},
  {  "4800",  CBR_4800},
  {  "9600",  CBR_9600},
  { "14400", CBR_14400},
  { "19200", CBR_19200},
  { "38400", CBR_38400},
  { "56000", CBR_56000},
  { "57600", CBR_57600},
  {"115200",CBR_115200},
  {"128000",CBR_128000},
  {"256000",CBR_256000},
};

DWORD preset_baud_rate(LPSTR lpszCmd)
{
  int   i,table_len,found = 0;
  DWORD baudrate = CBR_9600;

//  _cprintf("Command line string:\r\n\"%s\"\r\n",lpszCmd);
  table_len = sizeof(BaudRates)/sizeof(BaudRates[0]);
  for(i = 0;i < table_len;i++) {
    if(strcmp(lpszCmd,BaudRates[i].baudname) == 0) {
      baudrate = BaudRates[i].baudrate;
      found = 1;
      break;
    }
  }
  if(found) {
    _cprintf("Set baudrate to %s bauds\r\n",BaudRates[i].baudname);
  }
  else {
    if(strlen(lpszCmd) > 0) {
      _cprintf("Non standard baudrate. Set baudrate to 9600 bauds\r\n");
    }
    else {
      _cprintf("Set default baudrate 9600 bauds\r\n");
    }
  }
  ComPort_PresetParameters(baudrate,8,NOPARITY,ONESTOPBIT);	// optional function
  return baudrate;
}

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpszCmd,int nShow)
{
  int   c,com_port = 2;
  char  ch = 0;
  char  str[80];
  LPSTR arg_str;
  BOOL  bOpened,ESC_flag = 0;
#if PROTOCOL_ENABLE
  FILE* protocol;
#endif
/*
  BOOL  flag = TRUE,bResult;  // Need for ComPort_ChangeParameters example
*/

  arg_str = lpszCmd;
  _cprintf("\r\nComPortExample program started\r\n");
  _cprintf("Usage:\r\nComPortExample [com1] [baudrate]\r\n");
  _cprintf("Parameter [com1] is optional for COM1 port using. Default is COM2\r\n");
  _cprintf("Parameter [baudrate] can be number of bauds: 110,300,600...256000\r\n");
#if PROTOCOL_ENABLE
  if((protocol = fopen("protocol.txt","wb")) == NULL) {
    printf("Cannot open output file \"protocol.txt\".\n");
    return 1;
  }
#endif
  if(sscanf(arg_str,"%20s",str) == 1) {
    if(_stricmp("com1",str) == 0) {
      com_port = 1;
      arg_str+= strlen(str);
    }
  }
  if(sscanf(arg_str,"%20s",str) == 0) {
    strcpy(str,"");
  }
  preset_baud_rate(str);
  sprintf(str,"COM%d",com_port);
  bOpened = ComPort_Open(str);
//  Anywhere in the program we can use functions:
//  bOpened = ComPort_GetOpenedStatus();
//  bResult = ComPort_ChangeParameters(...);
  if(!bOpened) {
    _cprintf("Can't open port %s!\r\nExiting...\r\n",str);
#if PROTOCOL_ENABLE
    fclose(protocol);
#endif
    return 1;
  }
  else {
    _cprintf("Serial port %s successfully opened\r\n",str);
    _cprintf("Keyboard input comes to port\r\n");
#if PROTOCOL_ENABLE
    _cprintf("Port output comes to screen and \"protocol.txt\" file\r\n");
#else
    _cprintf("Port output comes to screen\r\n");
#endif
    _cprintf("Press ESC, ESC to exit\r\n");
  }
  while(1) {
    if(_kbhit()) {
      ch = _getch();
/*
      ComPort_ChangeParameters example

      if(ch == 'c' || ch == 'C') {
        if(flag) {
          flag = FALSE;
          bResult = ComPort_ChangeParameters(CBR_4800,8,NOPARITY,ONESTOPBIT);
          _cprintf("Change to 4800 %s\r\n",(bResult)?"completed":"failed");
        }
        else {
          flag = TRUE;
          bResult = ComPort_ChangeParameters(CBR_9600,8,NOPARITY,ONESTOPBIT);
          _cprintf("Change to 9600 %s\r\n",(bResult)?"completed":"failed");
        }
        continue;
      }
*/
      ComPort_PutByte(ch);
      if(ch == ESC) {
        if(ESC_flag) break;
        ESC_flag = 1;
      }
      else {
        ESC_flag = 0;
      }
    }
    if((c = ComPort_GetByte(20)) != -1) {
      _putch(c);
#if PROTOCOL_ENABLE
      fputc(c,protocol);
#endif
    }
  }
#if PROTOCOL_ENABLE
  fclose(protocol);
#endif
  ComPort_Close();
  return 0;
}
